# TODO
# - move tmpwatch R: to php-session package (as session files file storage no
#   longer can cleanup itself due dir perms)
# - https://fedorahosted.org/tmpwatch/ticket/7 is implemented in tmpwatch-2.9.16, see 3467603 todo
Summary:	Common dirs for PHP
Summary(pl.UTF-8):	Wspólne katalogi dla PHP
Name:		php-dirs
Version:	1.10
Release:	2
License:	GPL
Group:		Base
Source0:	php-session.sh
Source1:	%{name}.tmpfiles
Source2:	crontab
BuildRequires:	rpmbuild(macros) >= 1.644
Requires(postun):	/usr/sbin/groupdel
Requires(pre):	/usr/bin/getgid
Requires(pre):	/usr/sbin/groupadd
Requires:	tmpwatch
Conflicts:	php-pear < 4:1.4-2
Provides:	group(http)
BuildArch:	noarch
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		_libexecdir	%{_prefix}/lib

%description
Common directories for PHP.

%description -l pl.UTF-8
Wspólne katalogi dla PHP.

%prep

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{/etc/cron.d,/var/{cache,log,run}/php,/var/log/archive/php} \
	$RPM_BUILD_ROOT%{_docdir}/phpdoc \
	$RPM_BUILD_ROOT%{_libexecdir} \
	$RPM_BUILD_ROOT%{systemdtmpfilesdir}

install -p %{SOURCE0} $RPM_BUILD_ROOT%{_libexecdir}
cp -p %{SOURCE1} $RPM_BUILD_ROOT%{systemdtmpfilesdir}/%{name}.conf
sed -e 's,@libexecdir@,%{_libexecdir},' %{SOURCE2} >$RPM_BUILD_ROOT/etc/cron.d/php-session

while read dir; do
	install -d $RPM_BUILD_ROOT$dir
done <<EOF
%{php_data_dir}/tests
%{php_data_dir}/Symfony/Bridge
%{php_data_dir}/Symfony/Component
EOF

%clean
rm -rf $RPM_BUILD_ROOT

%pre
%groupadd -g 51 http

%postun
if [ "$1" = "0" ]; then
	%groupremove http
fi

%files
%defattr(644,root,root,755)
%config(noreplace) %verify(not md5 mtime size) /etc/cron.d/php-session
%{systemdtmpfilesdir}/%{name}.conf
%attr(755,root,root) %{_libexecdir}/php-session.sh
%{php_data_dir}

%dir %{_docdir}/phpdoc
%attr(775,root,http) %dir %verify(not group mode) /var/log/php
%attr(770,root,root) %dir %verify(not group mode) /var/log/archive/php

# no +r, so only predictable names can be used. currently php-soap wsdl cache is there
%attr(730,root,http) %dir %verify(not group mode) /var/cache/php

# http needs only +x for directory
# (otherwise it knows session file names and can read it contents)
# keep o+x for fcgi.sock (lighttpd)
%attr(731,root,http) %dir %verify(not group mode) /var/run/php
%changelog
* Fri Jun 24 2022 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/php-dirs.git;a=log;h=master

* Fri Jun 24 2022 Arkadiusz Miśkiewicz <arekm@maven.pl> 8b8822b
- Rel 2; base on /etc/php directories since these always exist (while binaries are optional)

* Wed May 23 2018 Jakub Bogusz <qboosh@pld-linux.org> cd8a237
- don't hardcode libexecdir in crontab source file

* Wed May 02 2018 Arkadiusz Miśkiewicz <arekm@maven.pl> 088a0e8
- 1.10; but only catch version ending binaries

* Wed May 02 2018 Arkadiusz Miśkiewicz <arekm@maven.pl> 8fb1731
- 1.9; tmpwatch is required here (until TODO is finished); otherwise session files are not cleaned up and system boot takes long hours (rc-scripts deletes milions of files in /var/... at boot)

* Wed May 02 2018 Arkadiusz Miśkiewicz <arekm@maven.pl> 5e40448
- ver 1.8. use ls to find possible php commands

* Sat Apr 14 2018 Elan Ruusamäe <glen@pld-linux.org> 17007ec
- php-session: include php71 and php72

* Sun May 01 2016 Elan Ruusamäe <glen@delfi.ee> 8c92a47
- tmpwatch has minutes now. see 3467603

* Sun May 01 2016 Elan Ruusamäe <glen@delfi.ee> fa4cff7
- add php70 to php search list

* Sun May 01 2016 Elan Ruusamäe <glen@delfi.ee> 21e70d8
- v1.7: add crontab file

* Tue Jan 05 2016 Elan Ruusamäe <glen@delfi.ee> 0bcfd37
- v1.6: move /usr/share/php subdirs here; cleanup descs

* Thu Dec 11 2014 Elan Ruusamäe <glen@delfi.ee> 2c1170a
- skip missing dirs

* Thu Dec 11 2014 Elan Ruusamäe <glen@delfi.ee> c2fd47f
- move gc lookup to function, add php56

* Thu Dec 11 2014 Elan Ruusamäe <glen@delfi.ee> 3bb55b2
- revert 37fa3e2, gc_time is not dependant on cleaned up dir

* Thu Dec 11 2014 Arkadiusz Miśkiewicz <arekm@maven.pl> 37fa3e2
- rel 2; process /var/run/php-ug for itk, too

* Mon Oct 28 2013 Elan Ruusamäe <glen@delfi.ee> 36964bd
- call it v1.5

* Sat Oct 26 2013 Elan Ruusamäe <glen@delfi.ee> a475607
- use tmpwatch with --test to remove only files matching to 'sess_*' pattern

* Fri Oct 18 2013 Jan Rękorajski <baggins@pld-linux.org> b99de54
- rel 4

* Fri Oct 18 2013 Jan Rękorajski <baggins@pld-linux.org> b6be035
- Revert "do not use dot in run-parts scanned dir"

* Fri Oct 18 2013 Elan Ruusamäe <glen@delfi.ee> e40788e
- do not use dot in run-parts scanned dir

* Sat Jul 06 2013 Elan Ruusamäe <glen@delfi.ee> ec175e5
- package /var/log/archive/php

